---
title: "@prismicio/react - v3"
tags: ["latest"]
category: "api-references"
audience: developers
lastUpdated: "2026-09-17T06:13:24.000Z"
---

# Overview

`@prismicio/react` is the official Prismic package for creating [React](https://react.dev/)-based websites.

With this package, you can:

* Display Prismic [images](https://prismic.io/docs/fields/image.md), [links](https://prismic.io/docs/fields/link.md), and [rich text](https://prismic.io/docs/fields/rich-text.md) using components.
* Display [slice zones](https://prismic.io/docs/slice.md) with custom components.

This page documents all APIs provided by `@prismicio/react`.

> See the [Next.js guide](https://prismic.io/docs/nextjs.md) to learn how to build websites using this package.

> **Important**
>
> We only guarantee support with Next.js websites.

# Install

`@prismicio/react` is installed when you [set up](https://prismic.io/docs/nextjs.md#set-up-a-nextjs-website) a Next.js project with the Prismic CLI.

```sh
npx prismic init
```

It can also be manually installed in any React project:

```sh
npm install --save @prismicio/react @prismicio/client
```

[`@prismicio/client`](https://prismic.io/docs/technical-reference/prismicio-client.md) is a peer dependency and must be installed.

# API

All components can be imported as a named import.

The following example imports [`PrismicImage`](#prismicimage):

```ts
import { PrismicImage } from "@prismicio/react";
```

## `<PrismicImage>`

Displays an optimized image from an [image field](https://prismic.io/docs/fields/image.md).

```tsx
<PrismicImage field={slice.primary.image} />
```

> See examples and tips on the [image field](https://prismic.io/docs/fields/image.md#display-images) page.

| Prop                      | Type                                    | Description                                                                                                                                                                                                                             | Default      |
| ------------------------- | --------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------ |
| field                     | ImageField                              | An image field to display.                                                                                                                                                                                                              | None         |
| imgixParams (optional)    | object                                  | An object of [imgix URL parameters](https://docs.imgix.com/apis/rendering). See an [example](https://prismic.io/docs/fields/image.md#transform-images-through-the-api).                                                                 | None         |
| alt (optional)            | ""                                      | Declare an image as decorative.                                                                                                                                                                                                         | None         |
| fallbackAlt (optional)    | ""                                      | Declare an image as decorative if the image field does not have alt text.                                                                                                                                                               | None         |
| widths (optional)         | number\[] \| "thumbnails" \| "defaults" | Widths used to build a `srcset` value for the image field.- `"thumbnails"` uses the image field's thumbnails.
- `"defaults"` uses `[640, 750, 828, 1080, 1200, 1920, 2048, 3840]`.Only one of `widths` or `pixelDensities` can be used. | `"defaults"` |
| pixelDensities (optional) | number\[] \| "defaults"                 | Pixel densities used to build a `srcset` value for the image field.- `"defaults"` uses `[1, 2, 3]`.Only one of `widths` or `pixelDensities` can be used.                                                                                | None         |
| fallback (optional)       | ReactNode                               | Rendered if the image is empty.                                                                                                                                                                                                         | None         |

## `<PrismicLink>`

Displays a link from a [link field](https://prismic.io/docs/field.md#link) or Prismic document.

```tsx
<PrismicLink field={slice.primary.link} />
```

> See examples and tips on the [link field](https://prismic.io/docs/fields/link.md#display-links) page.

| Prop                         | Type                                                             | Description                                                                                                                                                                                                                                                   | Default                                 |
| ---------------------------- | ---------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------- |
| field                        | LinkField                                                        | A link field to link. Only one of `field`, `document`, or `href` can be used.                                                                                                                                                                                 | None                                    |
| document                     | PrismicDocument                                                  | A Prismic document to link. Only one of `field`, `document`, or `href` can be used.                                                                                                                                                                           | None                                    |
| href                         | string                                                           | A URL to link. Only one of `field`, `document`, or `href` can be used.                                                                                                                                                                                        | None                                    |
| rel (optional)               | undefined \| string \| ((metadata) => string \| undefined)       | A `ref` attribute. A function can be passed to determine the value based on the link. Use `undefined` to remove the `rel` attribute.                                                                                                                          | `"noreferrer"` if the link is external. |
| linkResolver (optional)      | (field: ContentRelationshipField) => string \| null \| undefined | A [link resolver](https://prismic.io/docs/route-resolver.md#link-resolver) function used to determine a URL from the `field` or `document` prop. If it returns a value, it takes priority over a [route resolver](https://prismic.io/docs/route-resolver.md). | None                                    |
| internalComponent (optional) | ComponentType                                                    | The component used to render internal links.                                                                                                                                                                                                                  | `<a>`                                   |
| externalComponent (optional) | ComponentType                                                    | The component used to render external links.                                                                                                                                                                                                                  | `<a>`                                   |

## `<PrismicText>`

Displays plain text from a [rich text field](https://prismic.io/docs/rich-text.md).

```tsx
<PrismicText field={slice.primary.text} />
```

| Prop                 | Type          | Description                               | Default |
| -------------------- | ------------- | ----------------------------------------- | ------- |
| field                | RichTextField | A rich text field to render.              | None    |
| fallback (optional)  | string        | Rendered if the rich text field is empty. | None    |
| separator (optional) | string        | Separator used between text blocks.       | `" "`   |

## `<PrismicRichText>`

Displays formatted text from a [rich text field](https://prismic.io/docs/rich-text.md).

```tsx
<PrismicRichText field={slice.primary.text} />
```

> See examples and tips on the [rich text field](https://prismic.io/docs/fields/rich-text.md#display-rich-text) page.

| Prop                             | Type                                                             | Description                                                                                                                                                                                                                                                                                                                                                                                                       | Default                                                    |
| -------------------------------- | ---------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------- |
| field                            | RichTextField                                                    | A rich text field to render.                                                                                                                                                                                                                                                                                                                                                                                      | None                                                       |
| fallback (optional)              | ReactNode                                                        | Rendered if the rich text field is empty.                                                                                                                                                                                                                                                                                                                                                                         | None                                                       |
| components (optional)            | object                                                           | A map of rich text block types to React components. The available heading types are `heading1` to `heading6`. The available block types are `paragraph`, `preformatted`, `list`, `oList`, `listItem`, `oListItem`, `image`, and `embed`. The available inline types are `strong`, `em`, `hyperlink`, `label`, and `span`. See an [example](https://prismic.io/docs/fields/rich-text.md#use-custom-ui-components). | Standard HTML elements (e.g. `heading1` becomes a `<h1>`). |
| linkResolver (optional)          | (field: ContentRelationshipField) => string \| null \| undefined | A [link resolver](https://prismic.io/docs/route-resolver.md#link-resolver) function used to determine a URL from the `field` or `document` prop. If it returns a value, it takes priority over a [route resolver](https://prismic.io/docs/route-resolver.md).                                                                                                                                                     | None                                                       |
| internalLinkComponent (optional) | ComponentType                                                    | The component used to render internal links.                                                                                                                                                                                                                                                                                                                                                                      | `<a>`                                                      |
| internalLinkComponent (optional) | ComponentType                                                    | The component used to render external links.                                                                                                                                                                                                                                                                                                                                                                      | `<a>`                                                      |

## `<PrismicTable>`

Displays a formatted table from a [table field](https://prismic.io/docs/fields/table.md).

```tsx
<PrismicTable field={slice.primary.my_table_field} />
```

> See examples and tips on the [table field](https://prismic.io/docs/fields/table.md#display-tables) page.

| Prop                  | Type       | Description                                                                                                                                                                                                                                                                                                                        | Default                                                    |
| --------------------- | ---------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------- |
| field                 | TableField | A table field to render.                                                                                                                                                                                                                                                                                                           | None                                                       |
| fallback (optional)   | ReactNode  | Rendered if the table field is empty.                                                                                                                                                                                                                                                                                              | None                                                       |
| components (optional) | object     | A map of table elements and rich text block types to React components. The available table elements are `table`, `thead`, `tbody`, `tr`, `th`, and `td`. The available rich text block types are `paragraph`, `em`, `strong`, and `hyperlink`. See an [example](https://prismic.io/docs/fields/table.md#use-custom-ui-components). | Standard HTML elements (e.g. `table` becomes a `<table>`). |

## `<SliceZone>`

Renders [slices](https://prismic.io/docs/slice.md) from a slice zone.

```tsx
<SliceZone
  slices={doc.data.slices}
  components={{
    text: ({ slice }) => (
      <section>
        <PrismicRichText field={slice.primary.text} />
      </section>
    ),
  }}
/>
```

> See examples and tips on the [slices](https://prismic.io/docs/slices.md#display-slices) page.

| Prop                        | Type                                                                        | Description                                            | Default |
| --------------------------- | --------------------------------------------------------------------------- | ------------------------------------------------------ | ------- |
| slices                      | SliceZone                                                                   | A slice zone to render.                                | None    |
| components                  | Record\<string, ComponentType\<SliceComponentProps>> (see definition below) | A map of slice types to React components.              | None    |
| defaultComponent (optional) | ComponentType                                                               | Rendered if a slice does not have a component mapping. | None    |
| context (optional)          | any                                                                         | Arbitrary data made available to all slice components. | None    |

**SliceComponentProps definition:**

| Property | Type     | Description                                        | Default |
| -------- | -------- | -------------------------------------------------- | ------- |
| slice    | Slice    | The slice object being displayed.                  | None    |
| slices   | Slice\[] | All slices in the slice zone.                      | None    |
| index    | number   | The index of the slice in the slice zone.          | None    |
| context  | unknown  | The data passed to `<SliceZone>`'s `context` prop. | None    |

## `<PrismicToolbar>`

Adds the [Prismic toolbar](https://prismic.io/docs/preview.md#the-toolbar).

```tsx
<PrismicToolbar repositoryName="example-prismic-repo" />
```

| Prop           | Type   | Description                         | Default |
| -------------- | ------ | ----------------------------------- | ------- |
| repositoryName | string | The name of the Prismic repository. | None    |

# Upgrade from v2

Follow these steps to upgrade an existing project to `@prismicio/react` v3.

> Most Next.js websites will not require code changes.

1. **Install `@prismicio/react` v3**

   ```sh
   npm install @prismicio/react@^3
   ```

2. **Create a custom `<PrismicRichText>`**

   > **Important**
   >
   > This step is only necessary when using `<PrismicProvider>`'s `richTextComponents` or `linkResolver` props.

   Create a custom `<PrismicRichText>` component with your default props. Use the custom component in place of `@prismicio/react`'s version.

   ```tsx filename=src/components/PrismicRichText.tsx
   import {
     PrismicRichText as BasePrismicRichText,
     PrismicRichTextProps,
     JSXMapSerializer,
   } from "@prismicio/react";

   const defaultComponents: JSXMapSerializer = {
     heading1: ({ children }) => (
       <h1 className="text-3xl font-bold">{children}</h1>
     ),
   };

   export function PrismicRichText({
     components,
     ...props
   }: PrismicRichTextProps) {
     return (
       <BasePrismicRichText
         components={{ ...defaultComponents, ...components }}
         {...props}
       />
     );
   }
   ```

3. **Create a custom `<PrismicLink>`**

   > **Important**
   >
   > This step is only necessary when using `<PrismicProvider>`'s `internalLinkComponent`, `externalLinkComponent` or `linkResolver` props.

   Create a custom `<PrismicLink>` component with your default props. Use the custom component in place of `@prismicio/react`'s version.

   ```tsx filename=src/components/PrismicLink.tsx
   import {
     PrismicLink as BasePrismicLink,
     PrismicLinkProps,
     LinkProps,
   } from "@prismicio/react";

   function InternalLink(props: LinkProps) {
     return <a className="internal" {...props} />;
   }

   export function PrismicLink(props: PrismicLinkProps) {
     return <BasePrismicLink internalComponent={InternalLink} {...props} />;
   }
   ```

4. **Replace `usePrismicClient()`**

   Use a reference to a client instead.

   ```tsx
   import { client } from "../prismicio"; // [!code ++]

   function Example() {
     // Use the imported `client` instead. // [!code --]
     const client = usePrismicClient(); // [!code --]

     return <div>An example component</div>;
   }
   ```

   We recommend exporting a client from a root-level file named `prismicio.ts`.

   ```tsx filename=prismicio.ts
   import { createClient } from "@prismicio/client";

   export const client = createClient("example-prismic-repo");
   ```

5. **Replace `usePrismicPreviewResolver()`**

   Use [`client.resolvePreviewURL()`](https://prismic.io/docs/technical-reference/prismicio-client/v7.md#clientresolvepreviewurl) and your router's redirect function instead.

   ```tsx
   import { redirect } from "react-router";
   import { useEffect } from "react"; // [!code ++]
   import { client } from "../prismicio"; // [!code ++]

   function PreviewPage() {
     usePrismicPreviewResolver({ navigate: redirect }); // [!code --]
     // prettier-ignore
     useEffect(() => { // [!code ++]
       client // [!code ++]
         .resolvePreviewURL({ defaultURL: "/" }) // [!code ++]
         .then((url) => redirect(url)); // [!code ++]
     }, []); // [!code ++]

     return <div>Loading...</div>;
   }
   ```

6. **Replace all query hooks**

   Use a query library with a Prismic client, such as [TanStack Query](https://tanstack.com/query).

   ```tsx
   import { usePrismicDocumentByUID } from "@prismicio/react"; // [!code --]
   import { useQuery } from "@tanstack/react-query"; // [!code ++]
   import { client } from "../prismicio"; // [!code ++]

   function Home() {
     const [page] = usePrismicDocumentByUID("page", "home"); // [!code --]
     // prettier-ignore
     const { data } = useQuery({ // [!code ++]
       queryKey: ["home"], // [!code ++]
       queryFn: () => client.getByUID("page", "home"), // [!code ++]
     }); // [!code ++]

     return <h1>{data?.data.title}</h1>;
   }
   ```

   > See [TanStack Query's Quick Start](https://tanstack.com/query/latest/docs/framework/react/quick-start) for details on `useQuery()`.

   Refer to the following table for each hook's replacement client method.

   | Hook                                  | Query method                 |
   | ------------------------------------- | ---------------------------- |
   | `usePrismicDocuments()`               | `client.get()`               |
   | `useFirstPrismicDocument()`           | `client.getFirst()`          |
   | `useAllPrismicDocumentsDangerously()` | `client.dangerouslyGetAll()` |
   | `usePrismicDocumentByID()`            | `client.getByID()`           |
   | `usePrismicDocumentsByIDs()`          | `client.getByIDs()`          |
   | `useAllPrismicDocumentsByIDs()`       | `client.getAllByIDs()`       |
   | `usePrismicDocumentByUID()`           | `client.getByUID()`          |
   | `usePrismicDocumentsByUIDs()`         | `client.getByUIDs()`         |
   | `useAllPrismicDocumentsByUIDs()`      | `client.getAllByUIDs()`      |
   | `useSinglePrismicDocument()`          | `client.getSingle()`         |
   | `usePrismicDocumentsByType()`         | `client.getByType()`         |
   | `useAllPrismicDocumentsByType()`      | `client.getAllByType()`      |
   | `usePrismicDocumentsByTag()`          | `client.getByTag()`          |
   | `useAllPrismicDocumentsByTag()`       | `client.getAllByTag()`       |
   | `usePrismicDocumentsBySomeTags()`     | `client.getBySomeTags()`     |
   | `useAllPrismicDocumentsBySomeTags()`  | `client.getAllBySomeTags()`  |
   | `usePrismicDocumentsByEveryTag()`     | `client.getByEveryTag()`     |
   | `useAllPrismicDocumentsByEveryTag()`  | `client.getAllByEveryTag()`  |

7. **Remove `<PrismicProvider>`**

   `<PrismicProvider>` is no longer included.

   ```tsx
   import { PrismicProvider } from "@prismicio/react"; // [!code --]

   function App({ children }) {
     return (
       // prettier-ignore
       <PrismicProvider client={client}> // [!code --]
         {children}
       </PrismicProvider> // [!code --]
     );
   }
   ```

[app-router]: https://nextjs.org/docs/app

[pages-router]: https://nextjs.org/docs/pages

[next-image]: https://nextjs.org/docs/app/api-reference/components/image

[next-link]: https://nextjs.org/docs/app/api-reference/components/link


---
title: "@prismicio/vue - v3"
category: "api-references"
audience: developers
lastUpdated: "2025-11-06T01:07:50.000Z"
---

# Overview

`@prismicio/vue` is the official Prismic package for creating web apps with Prismic and Vue.js.

> <CalloutHeading>Package version</CalloutHeading>
>
> Are you on version 3 of `@prismicio/vue`? Follow our instructions to [upgrade to version 4](https://prismic.io/docs/prismicio-vue-v4-migration-guide.md).
>
> Version 3 and above of this package target Vue 3. To integrate Vue 2 with Prismic use version 2 of this package, `@prismicio/vue@^2`.

`@prismicio/vue` provides three main functionalities:

* **Plugin:** It provides an instance of the client and helper functions from `@prismicio/client` instance, preconfigures and exposes helpers from `@prismicio/helpers`, and registers components globally.
* **Components**: It provides a collection of components to render content from Prismic documents.
* **Client composables**: It provides Vue composables to use with the [Composition API](https://v3.vuejs.org/guide/composition-api-introduction.html) to query content from a Prismic repository.

# Dependencies and requirements

This package can only be used in a Vue project. It provides `@prismicio/client` and `@prismicio/helpers` so you don't need to install them explicitly. However, if you need to import things directly from them for any reason, you can still install them alongside `@prismicio/vue`.

Since this is a general-purpose Vue.js library, it can be used in simple setups like [Vue CLI](https://next.cli.vuejs.org) and [Vite](https://vitejs.dev) or in more advanced frameworks that use Vue, like [Nuxt](https://v3.nuxtjs.org), although we also offer a specific integration for the latter: [`@nuxtjs/prismic`](https://prismic.nuxtjs.org).

# Installation

## Install packages

Add `@prismicio/vue` to your Vue project via the command line:

```bash
npm install @prismicio/vue
```

## Create an optional link resolver

Create a link resolver function. This is one of the two ways to tell Vue how to handle internal links in Prismic documents. (The other way to do so is with a route resolver, which works better for more complex routes. [Read a comparison](https://prismic.io/docs/route-resolver.md).)

A link resolver function takes a document from Prismic as an argument and returns the URL path for that document. Here's a basic example of a `linkResolver.js` file.

```tsx
export function linkResolver(document) {
  if (document.type === "post") {
    return "/blog/" + document.uid;
  }

  return "/";
}
```

## Set up the plugin

The plugin allows settings for `@prismicio/vue`'s Vue components, composables, client and helpers to be configured in one central location. This is done using Vue plugin system.

Here's an example of setting up the plugin in a `prismic.js` file.

```tsx
import { createPrismic } from "@prismicio/vue";

import { linkResolver } from "./linkResolver";

const prismic = createPrismic({
  endpoint: "your-endpoint",
  linkResolver,
});

export default prismic;
```

Additional options for `createPrismic()` are described below.

Once created, you can add the plugin to your Vue application.

```tsx
import { createApp } from "vue";
import App from "./App.vue";
import prismic from "./prismic";

createApp(App).use(prismic).mount("#app");
```

# Plugin usage

## `createPrismic()`

```tsx
createPrismic(options);
```

A factory function used to create a configured plugin instance to be used by the Vue application.

```tsx
import { createApp } from "vue";
import { createPrismic } from "@prismicio/vue";
import App from "./App.vue";

const prismic = createPrismic({
  endpoint: "your-repo-name",
});

createApp(App).use(prismic).mount("#app");
```

`createPrismic()` object accepts the following properties. Only `endpoint` or `client` are mandatory (at least one of the two):

<Table>
  <tbody>
    <tr>
      <TableCell>
        `endpoint`
      </TableCell>

      <TableCell>
        A Prismic repository endpoint to init the plugin's **@prismicio/client** instance used to fetch content from a Prismic repository with. Can be either just the repository ID (**your-repo-name**) or the full API endpoint (**[https://your-repo-name.cdn.prismic.io/api/v2](https://your-repo-name.cdn.prismic.io/api/v2)**).
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `clientConfig`
      </TableCell>

      <TableCell>
        An optional object used to configure the created **@prismicio/client** instance further. See the [**@prismicio/client** documentation](https://prismic.io/docs/technical-reference/prismicio-client?version=v6) for configuration options.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `client`
      </TableCell>

      <TableCell>
        A **@prismicio/client** instance used to fetch content from a Prismic repository to configure the plugin with. This option is to be used instead of the two previous ones (**endpoint** & **clientConfig**).
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `linkResolver`
      </TableCell>

      <TableCell>
        An optional link resolver function used to resolve links to Prismic documents when not using the route resolver parameter with **@prismicio/client**. See the [link resolver documentation](https://prismic.io/docs/route-resolver.md).
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `richTextSerializer`
      </TableCell>

      <TableCell>
        An optional [rich text serializer](https://prismic.io/docs.md) to customize the way rich text fields are rendered.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `injectComponents`
      </TableCell>

      <TableCell>
        Whether or not to inject components globally. Defaults to **true**.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components`
      </TableCell>

      <TableCell>
        An optional options object used to configure injected components default behavior, see details below.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.linkBlankTargetRelAttribute`
      </TableCell>

      <TableCell>
        Value of the **rel** attribute to use on links rendered with **target="\_blank"**. Defaults to **"noopener noreferrer"**.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.linkInternalComponent`
      </TableCell>

      <TableCell>
        An HTML tag name, a component, or a functional component used to render internal links. Defaults to Vue Router `<RouterLink>` component if available.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.linkExternalComponent`
      </TableCell>

      <TableCell>
        An HTML tag name, a component, or a functional component used to render external links. Defaults to **"a"**.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.imageComponent`
      </TableCell>

      <TableCell>
        An HTML tag name, a component, or a functional component used to render images. Defaults to **"img"**.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.imageWidthSrcSetDefaults`
      </TableCell>

      <TableCell>
        Default widths to use when rendering an image with **widths="defaults"**. Defaults to \*\*@prismicio/client \*\* defaults.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.imagePixelDensitySrcSetDefaults`
      </TableCell>

      <TableCell>
        Default pixel densities to use when rendering an image with **pixel-densities="defaults"**. Defaults to \*\*@prismicio/client \*\* defaults.
      </TableCell>
    </tr>

    <tr>
      <TableCell>
        `components.sliceZoneDefaultComponent`
      </TableCell>

      <TableCell>
        A component or a functional component rendered if a **component** mapping from the components prop cannot be found. Defaults to **null** when **process.env.NODE\_ENV === "production".** When not, it defaults to a TODO slice component.
      </TableCell>
    </tr>
  </tbody>
</Table>

## `usePrismic()` and `this.$prismic`

```tsx
usePrismic();
this.$prismic;
```

By default, the plugin configures and injects in Vue context:

* An `@prismicio/client` instance at `client`, as well as `predicate` and `cookie`
* `asText`, `asHTML`, `asLink`, `asDate`, `asImageSrc`, `asImageWidthSrcSet`, `asImagePixelDensitySrcSet` helpers from ` @prismicio/client`

All those properties and methods can be accessed using the `usePrismic()` composable when using the [Composition API](https://v3.vuejs.org/guide/composition-api-introduction.html).

```tsx
import { usePrismic } from "@prismicio/vue";

const { client, asDate } = usePrismic();

// ...
```

When using the Options API they can be accessed through the Vue instance.

```tsx
export default {
  mounted() {
    this.$prismic.client(/* ... */);
    this.$prismic.asDate(/* ... */);

    // ...
  },
};
```

All components described below will also be injected globally by the plugin when leaving the `injectComponents` option to `true`. No imports are required.

```html
<template>
  <PrismicRichText :field="document.data.myRichTextField" />
</template>
```

# Components usage

`@prismicio/vue` provides a collection of components to render content from Prismic documents. These components are injected globally when the plugin is configured.

## `<PrismicRichText>`

```tsx
// Not necessary when using the plugin
import { PrismicRichText } from "@prismicio/vue";
```

A Vue component that renders content from a Prismic rich text or title field.

By default, HTML elements are rendered for each piece of content. For example, a `heading1` block will render an `<h1>` HTML element. Internal links will use Vue Router, if available, for routing.

```html
<PrismicRichText :field="document.data.myRichTextField" />
```

This component wraps its output in a `<div>` tag, if you need another wrapper tag, or component, to be used, use the `wrapper` prop.

```html
<PrismicRichText :field="document.data.myRichTextField" wrapper="article" />
```

A `fallback` prop can be provided to define an HTML string to render when the rich text or title field is empty. If a `fallback` prop is not provided, `""` (nothing) is rendered by default for an empty field.

```html
<PrismicRichText
  :field="document.data.myRichTextField"
  fallback="<p>No content</p>"
/>
```

By default, if you're using the plugin, the component will use the link resolver, and a custom [rich text serializer](https://prismic.io/docs.md) is provided through its `linkResolver` and `serializer` options. In any case, you can still provide those explicitly to the component using the `linkResolver` and `serializer` props:

```html
<PrismicRichText
  :field="document.data.myRichTextField"
  :link-resolver="linkResolver"
  :serializer="serializer"
/>
```

For lower-level use cases, a composable is also available to replicate this component behavior. It uses the same props as options, except the `wrapper` prop, which is omitted.

```tsx
import { usePrismicRichText } from "@prismicio/vue";

const { html } = usePrismicRichText({
  field: document.data.myRichTextField,
});
```

## `<PrismicText>`

```tsx
// Not necessary when using the plugin
import { PrismicText } from "@prismicio/vue";
```

Vue component that renders content from a Prismic rich text or title field as plain text.

```html
<PrismicText :field="document.data.myTitleField" />
```

This component wraps its output in a `<div>` tag. To use a different wrapper tag or wrapper component, use the `wrapper` prop.

```html
<PrismicText :field="document.data.myTitleField" wrapper="h1" />
```

A `fallback` prop can be provided to define a string to render when the rich text or title field is empty. If a `fallback` prop is not provided, `""` (nothing) is rendered by default for an empty field.

```html
<PrismicText :field="document.data.myTitleField" fallback="No content" />
```

For lower-level use cases, a composable is also available to replicate this component behavior. It uses the same props as options, except the `wrapper` prop, which is omitted.

```tsx
import { usePrismicText } from "@prismicio/vue";

const { text } = usePrismicText({
  field: document.data.myTitleField,
});
```

## `<PrismicLink>`

```tsx
// Not necessary when using the plugin
import { PrismicLink } from "@prismicio/vue";
```

Vue component that renders a link from a Prismic link field or a Prismic document.

This component automatically resolves a field's link to a URL. It also applies the correct `target` and `rel` props if *Open in new tab* is enabled for the field.

```html
<PrismicLink :field="document.data.myLinkField"> Click me </PrismicLink>
```

You can also create a link from a document the very same way.

```html
<PrismicLink :field="document"> Click me </PrismicLink>
```

By default, the `<RouterLink>` component from Vue Router is used to render internal links, and an `<a>` HTML element is used for external ones.

These defaults can be overridden globally using the plugin `components.linkInternalComponent` and `components.linkExternalComponent` options or locally by using the `internalComponent` and `externalComponent` props.

```html
<PrismicLink
  :field="document.data.myLinkField"
  :internalComponent="MyInternalLink"
  :externalComponent="MyExternalLink"
>
  Click me
</PrismicLink>
```

If your app uses route resolvers when querying for documents, providing a link resolver is optional.

If your app does not use the route resolver, or requires an override for specific URLs, the component will use the link resolver provided to the plugin through its `linkResolver` option if you're using it or through the component's `linkResolver` prop. The `linkResolver` component prop will take precedence over the `linkResolver` plugin option.

```html
<PrismicLink :field="document.data.myLinkField" :linkResolver="linkResolver">
  Click me
</PrismicLink>
```

By default, if *"Open in new tab"* is enabled for the field, the component will render the `rel` attribute with a value of `"noopener noreferrer"`.

This default can be overridden globally using the plugin `components.linkBlankTargetRelAttribute` option or locally by using the `blankTargetRelAttribute` prop.

```html
<PrismicLink
  :field="document.data.myLinkField"
  blank-target-rel-attribute="noopener"
>
  Click me
</PrismicLink>
```

The `target` and `rel` props allows your to set explicit value for those attributes.

```html
<PrismicLink :field="document.data.myLinkField" target="_top" rel="noopener">
  Click me
</PrismicLink>
```

For lower-level use cases, a composable is also available to replicate this component behavior. It uses the same props as options.

```tsx
import { usePrismicLink } from "@prismicio/vue";

const {
  type, // suggested, unresolved, component to render
  href,
  target,
  rel,
} = usePrismicLink({ field: document.data.myLinkField });
```

## `<PrismicImage>`

```tsx
// Not necessary when using the plugin
import { PrismicImage } from "@prismicio/vue";

<PrismicImage :field="document.data.myImageField" />
```

By default, an `<img />` HTML element is used to render images.

This default can be overridden globally using the plugin `components.imageComponent` option or locally by using the `imageComponent` prop.

```html
<PrismicImage
  :field="document.data.myImageField"
  :image-component="MyImageComponent"
/>
```

When using a custom image component, it receives `src`, `srcset`, `alt`, and `copyright` values as additional props.

Imgix parameters can be applied to the rendered image using the `imgix-params` prop.

```html
<PrismicImage
  :field="document.data.myImageField"
  :imgix-params="{ sat: 100 }"
/>
```

Refer to [Imgix URL parameters reference](https://docs.imgix.com/apis/rendering) for all available options.

An image with a width-based `srcset` attribute can be rendered using the `widths` prop.

```html
<PrismicImage :field="document.data.myImageField" :widths="[600, 900, 1200]" />
<!--
<img alt="..." src="..." srcset="...?width=600 600w, ...?width=900 900w, ...?width=1200 1200w" />
-->
```

The `widths` prop accepts two special values:

* `thumbnails` bases the widths on your image field and its responsive views.
* `defaults` bases the widths on the plugin `components.imageWidthSrcSetDefaults` option and fallbacks to [`@prismicio/client `](https://prismic.io/docs/technical-reference/prismicio-helpers#asimagewidthsrcset) defaults if not specified.

```html
<PrismicImage :field="document.data.myImageField" widths="thumbnails" />
<!-- `srcset` is based on your responsive views
<img alt="..." src="..." srcset="...?width=400 400w, ...?width=800 800w, ...?width=1200 1200w" />
-->

<PrismicImage :field="document.data.myImageField" widths="defaults" />
<!-- `srcset` is based on the plugin option
<img alt="..." src="..." srcset="...?width=600 600w, ...?width=900 900w, ...?width=1200 1200w" />
-->
```

See [MDN's Responsive Images](https://developer.mozilla.org/en-US/docs/Learn/HTML/Multimedia_and_embedding/Responsive_images) guide to learn more about `srcset` and its variations.

An image with a pixel-density-based `srcset` attribute can be rendered using the `pixel-densities` prop.

```html
<PrismicImage :field="document.data.myImageField" :pixel-densities="[1, 2]" />
<!--
<img alt="..." src="..." srcset="...?dpr=1 1x, ...?dpr=2 2x" />
-->
```

The `pixel-densities` prop accepts one special value of `defaults`. It bases the pixel densities on the plugin `components.imagePixelDensitySrcSetDefaults` option and fallbacks to `defaults` if not specified.

```html
<PrismicImage :field="document.data.myImageField" pixel-densities="defaults" />
<!-- `srcset` is based on the plugin option
<img alt="..." src="..." srcset="...?dpr=1 1x, ...?dpr=2 2x, ...?dpr=3 3x" />
-->
```

To learn more about `srcset` and its variations, see [MDN’s Responsive Images guide](https://developer.mozilla.org/en-US/docs/Learn/HTML/Multimedia_and_embedding/Responsive_images).

For lower-level use cases, a composable is also available to replicate this component behavior. It uses the same props as options, except the `image-component` prop, which is omitted.

```tsx
import { usePrismicImage } from "@prismicio/vue";

const { src, srcset, alt, copyright } = usePrismicImage({
  field: document.data.myImageField,
});
```

## `<PrismicEmbed>`

```tsx
// Not necessary when using the plugin
import { PrismicEmbed } from "@prismicio/vue";
```

Vue component that renders content from a Prismic embed field.

```html
<PrismicEmbed :field="document.data.myEmbedField" />
```

This component wraps its output in a `<div>` tag. To use another wrapper tag or wrapper component, use the `wrapper` prop.

```html
<PrismicEmbed :field="document.data.myEmbedField" wrapper="h1" />
```

This component's role is to render a Prismic embed field safely. Because Prismic is not able to predict the nature of your embed output, it's your duty to style it accordingly. For that purpose you can target the data attributes generated by `<PrismicEmbed>` in your CSS.

```css
/* Style text type embed */
[data-oembed-type="text"] {
  /* ... */
}

/* Style YouTube embed */
[data-oembed-provider="YouTube"] {
  /* ... */
}

/* Style embed from figma.com */
[data-oembed*="figma.com"] {
  /* ... */
}
```

## `<SliceZone>`

```tsx
// Not necessary when using the plugin
import { SliceZone } from "@prismicio/vue";
```

Vue component that renders content from a Prismic slice zone using Vue components for each type of slice.

For example, if a slice zone contains a Text slice followed by an Images slice, `<SliceZone>` will render `<TextSlice>` and `<ImagesSlice>` in a list.

```html
<SliceZone
  :slices="document.data.body"
  :components="defineSliceZoneComponents({
    text: TextSlice,
    images: ImagesSlice,
  })"
/>
```

Alongside the `slices` prop, an object of slice type IDs (for example: "text") mapped to its Vue component (for example: `<TextSlice>`) should be provided to the `components` prop. Components can be supplied in a variety of ways.

To ensure that the map is defined properly — and to handle some edge-cases — we provide `defineSliceZoneComponents()` as a helper. We highly recommend using it when defining your components map.

```tsx
import { defineAsyncComponent } from "vue";
import { defineSliceZoneComponents } from "@prismicio/vue";

import FooSlice from "~/slices/FooSlice";

const components = defineSliceZoneComponents({
  // Explicit import
  foo: FooSlice,

  // Assuming "BarSlice" is registered globally in your Vue application
  bar: "BarSlice",

  // Async components are also a great way to achieve code splitting
  baz: defineAsyncComponent(() => import("~/slices/BazSlice.vue")),
});
```

Slice components are passed four props:

* `slice`: The slice object being rendered.
* `index`: The index of the slice within the slice zone.
* `slices`: The list of all slice objects in the slice zone.
* `context`: Arbitrary data passed to the `<SliceZone>`'s `context` prop.

Because defining props in Vue.js is verbose, we provide a helper function to do so: `getSliceComponentProps()`. With it, a simple slice component could look like this.

```html
<template>
  <PrismicRichText :field="slice.primary.text" />
</template>

<!-- Composition API -->
<script setup>
  import { getSliceComponentProps } from "@prismicio/vue";

  // The array passed to `getSliceComponentProps` is purely optional and acts as a visual hint for you
  defineProps(getSliceComponentProps(["slice", "index", "slices", "context"]));
</script>

<!-- Options API -->
<script>
  import { getSliceComponentProps } from "@prismicio/vue";

  export default {
    // The array passed to `getSliceComponentProps` is purely optional and acts as a visual hint for you
    props: getSliceComponentProps(["slice", "index", "slices", "context"]),
  };
</script>
```

If you have data that needs to be shared with all slice components, provide a value to the `context` prop of the `<SliceZone>` component. The value will be passed to each slice component as a `context` prop.

```html
<SliceZone
  :slices="document.data.body"
  :components="defineSliceZoneComponents({
    text: TextSlice,
    images: ImagesSlice,
  })"
  :context="{ foo: 'bar' }"
/>
```

By default, a "TODO" component will be rendered with a warning if a component is not provided for a slice type.

This default can be overridden globally using the plugin `components.sliceZoneDefaultComponent` option or locally by using the `defaultComponent` prop. The default component is passed the same props listed above.

```html
<SliceZone :slices="document.data.body" :default-component="() => null" />
```

The default "TODO" component will not be rendered in production (i.e. when `process.env.NODE_ENV` is `production`).

The `<SliceZone>` component renders with no wrapping element around the list of slice components. If you need a wrapper tag or component, you can use the `wrapper` prop.

```html
<SliceZone
  :slices="document.data.body"
  :components="defineSliceZoneComponents({
    text: TextSlice,
    images: ImagesSlice,
  })"
  wrapper="article"
/>
```

# Composables usage

`@prismicio/vue` provides Vue composables to use with the [Composition API](https://v3.vuejs.org/guide/composition-api-introduction.html) to query content from a Prismic repository.

> <CalloutHeading>For client-rendered pages</CalloutHeading>
>
> These composables are designed for client-rendered Vue apps or pages. If you are using a Vue framework with server-side rendering (like Nuxt), prefer the framework's standard data fetching practices over these composables.

Every query method from a Prismic client, such as `getAllByType()` and `getSingle()`, is provided as a composable.

```tsx
import {
  useAllPrismicDocumentsByType,
  useSinglePrismicDocument,
} from "@prismicio/vue";

const { data: documents } = useAllPrismicDocumentsByType("page");
const { data: settingsDocument } = useSinglePrismicDocument("settings");
```

Composables return the fetching state in addition to the query result and a refresh function. This allows you to render, for example, a "loading" interface while the client is fetching results or a refresh button to get latest data.

```tsx
const {
  data: pages,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsByType("page");
```

`state` can be one of the following values:

* `"idle"`: The composable is waiting to query the repository.
* `"pending"`: The composable is querying the repository.
* `"success"`: The composable successfully queried the repository.
* `"error"`: The composable encountered an error while querying the repository.

`error` will contain the thrown error that can be a `PrismicError` object from `@prismic/client` if the composable fails to query the repository. The composable will be in the `error` state.

`refresh()` is a function that can be awaited. When called the composable will query again the repository.

All composables default to using the `@prismicio/client` instance injected by the plugin if you are using it. In any case, you can still provide an explicit `@prismicio/client` instance though the method's last parameter options object.

```tsx
import * as prismic from "@prismicio/client";

const endpoint = prismic.getEndpoint("your-repo-name");
const otherClient = prismic.createClient(endpoint);

const { data: documents } = useAllPrismicDocumentsByType("page", {
  client: otherClient,
});
```

Additionally, if a composable requires specific parameters, they can be provided through the same options object. Those parameters are the same as the one used by the related `@prismicio/client` method.

```tsx
const { data: frenchDocuments } = useAllPrismicDocumentsByType("page", {
  lang: "fr-fr",
});
```

## `usePrismicDocuments()`

```tsx
usePrismicDocuments();
usePrismicDocuments(params);
```

A composable that queries content from the Prismic repository.

This composable accepts the same parameters as the client's `get()` method.

```tsx
const { data: documents, state, error, refresh } = usePrismicDocuments();
```

## `useFirstPrismicDocument()`

```tsx
useFirstPrismicDocument();
useFirstPrismicDocument(params);
```

A composable that queries content from the Prismic repository and returns only the first result, if any.

This composable accepts the same parameters as the client's `getFirst()` method.

```tsx
const { data: document, state, error, refresh } = useFirstPrismicDocument();
```

## `usePrismicDocumentByID()`

```tsx
usePrismicDocumentByID(id);
usePrismicDocumentByID(id, params);
```

A composable that queries a document from the Prismic repository with a specific ID.

This composable accepts the same parameters as the client's `getByID()` method.

```tsx
const { data: document, state, error, refresh } = usePrismicDocumentByID("id");
```

## `usePrismicDocumentsByIDs()`

```tsx
usePrismicDocumentsByIDs(arrayOfIDs);
usePrismicDocumentsByIDs(arrayOfIDs, params);
```

A composable that queries documents from the Prismic repository with specific IDs.

This composable accepts the same parameters as the client's `getByIDs()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = usePrismicDocumentsByIDs(["id1", "id2"]);
```

## `useAllPrismicDocumentsByIDs()`

```tsx
useAllPrismicDocumentsByIDs(arrayOfIDs);
useAllPrismicDocumentsByIDs(arrayOfIDs, params);
```

A composable that queries all documents from the Prismic repository with specific IDs.

This composable accepts the same parameters as the client's `getAllByIDs()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsByIDs(["id1", "id2"]);
```

## `usePrismicDocumentByUID()`

```tsx
usePrismicDocumentByUID(documentType, uid);
usePrismicDocumentByUID(documentType, uid, params);
```

A composable that queries a document from the Prismic repository with a specific UID and custom type.

This composable accepts the same parameters as the client's `getByUID()` method.

```tsx
const {
  data: document,
  state,
  error,
  refresh,
} = usePrismicDocumentByUID("page", "uid");
```

## `usePrismicDocumentsByUIDs()`

```tsx
usePrismicDocumentsByUIDs(documentType, arrayOfUIDs);
usePrismicDocumentsByUIDs(documentType, arrayOfUIDs, params);
```

A composable that queries documents from the Prismic repository with specific UIDs of a custom type.

This composable accepts the same parameters as the client's `getByUIDs()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = usePrismicDocumentsByUIDs("page", ["uid1", "uid2"]);
```

## `useAllPrismicDocumentsByUIDs()`

```tsx
useAllPrismicDocumentsByUIDs(documentType, arrayOfUIDs);
useAllPrismicDocumentsByUIDs(documentType, arrayOfUIDs, params);
```

A composable that queries all documents from the Prismic repository with specific UIDs of a custom type.

This composable accepts the same parameters as the client's `getAllByUIDs()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsByUIDs("page", ["uid1", "uid2"]);
```

## `useSinglePrismicDocument()`

```tsx
useSinglePrismicDocument(documentType);
useSinglePrismicDocument(documentType, params);
```

A composable that queries a singleton document from the Prismic repository for a specific custom type.

This composable accepts the same parameters as the client's `getSingle()` method.

```tsx
const {
  data: document,
  state,
  error,
  refresh,
} = useSinglePrismicDocument("settings");
```

## `usePrismicDocumentsByType()`

```tsx
usePrismicDocumentsByType(documentType);
usePrismicDocumentsByType(documentType, params);
```

A composable that queries documents from the Prismic repository for a specific custom type.

This composable accepts the same parameters as the client's `getByType()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = usePrismicDocumentsByType("page");
```

## `useAllPrismicDocumentsByType()`

```tsx
useAllPrismicDocumentsByType(documentType);
useAllPrismicDocumentsByType(documentType, params);
```

A composable that queries all documents from the Prismic repository for a specific custom type.

This composable accepts the same parameters as the client's `getAllByType()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsByType("page");
```

## `usePrismicDocumentsByTag()`

```tsx
usePrismicDocumentsByTag(tag);
usePrismicDocumentsByTag(tag, params);
```

A composable that queries documents from the Prismic repository with a specific tag.

This composable accepts the same parameters as the client's `getByTag()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = usePrismicDocumentsByTag("fruit");
```

## `useAllPrismicDocumentsByTag()`

```tsx
useAllPrismicDocumentsByTag(tag);
useAllPrismicDocumentsByTag(tag, params);
```

A composable that queries all documents from the Prismic repository with a specific tag.

This composable accepts the same parameters as the client's `getAllByTag()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsByTag("fruit");
```

## `usePrismicDocumentsByEveryTag()`

```tsx
usePrismicDocumentsByEveryTag(arrayOfTags);
usePrismicDocumentsByEveryTag(arrayOfTags, params);
```

A composable that queries documents from the Prismic repository with specific tags. A document must be tagged with all of the queried tags to be included.

This composable accepts the same parameters as the client's `getByEveryTag()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = usePrismicDocumentsByTag(["fruit", "vegetable"]);
```

## `useAllPrismicDocumentsByEveryTag()`

```tsx
useAllPrismicDocumentsByEveryTag(arrayOfTags);
useAllPrismicDocumentsByEveryTag(arrayOfTags, params);
```

A composable that queries all documents from the Prismic repository with specific tags. A document must be tagged with all of the queried tags to be included.

This composable accepts the same parameters as the client's `getAllByEveryTag()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsByEveryTag(["fruit", "vegetable"]);
```

## `usePrismicDocumentsBySomeTags()`

```tsx
usePrismicDocumentsBySomeTags(arrayOfTags);
usePrismicDocumentsBySomeTags(arrayOfTags, params);
```

A composable that queries documents from the Prismic repository with specific tags. A document must be tagged with at least one of the queried tags to be included.

This composable accepts the same parameters as the client's `getBySomeTags()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = usePrismicDocumentsBySomeTags(["fruit", "vegetable"]);
```

## `useAllPrismicDocumentsBySomeTags()`

```tsx
useAllPrismicDocumentsBySomeTags(arrayOfTags);
useAllPrismicDocumentsBySomeTags(arrayOfTags, params);
```

A composable that queries all documents from the Prismic repository with specific tags. A document must be tagged with at least one of the queried tags to be included.

This composable accepts the same parameters as the client's `getAllBySomeTags()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = useAllPrismicDocumentsBySomeTags(["fruit", "vegetable"]);
```

## `dangerouslyUseAllPrismicDocuments()`

```tsx
dangerouslyUseAllPrismicDocuments(params);
```

A composable that queries content from the Prismic repository and returns all matching content. If no filters are provided, all documents will be fetched.

This composable accepts the same parameters as the client's `dangerouslyGetAll()` method.

```tsx
const {
  data: documents,
  state,
  error,
  refresh,
} = dangerouslyUseAllPrismicDocuments();
```

> **Important**
>
> We recommend caution when using `dangerouslyUseAllPrismicDocuments()`. Querying all documents in your repository is not performant, and should only be used in unique documents from the Prismic repository with specific tags. A document must be tagged with all of the queried tags to be included. cases.
